function data()
local buildNr = 20220428

return {
	info = {
		minorVersion = 7,
		build = buildNr,
		severityAdd = "NONE",
		severityRemove = "WARNING",
		name = _("eis_os_commonapi2").. " - "..buildNr,
		description = _("eis_os_commonapi2_desc"),
		authors = {
			{
			  name = "eis_os",
			  role = "CREATOR",
			  text = "",
			}
		},
		tags = {"Script Mod"},
		modid = "eis_os_commonapi2_1",
	},
	runFn = function (settings, modParams)
		if (commonapi ~= nil) then
			commonapi.repos._prepSettings(settings)
			commonapi.mods._addModifer()
			commonapi.repos._addModifer()
		end
	end,

	postRunFn = function (settings, modParams)
		if (commonapi ~= nil) then
			if (commonapi._native ~= nil and commonapi._native.renameLuaState ~= nil) then
				commonapi._native.renameLuaState("postRunFn Thread")
			end

			commonapi.repos._prepPostRun(settings, modParams)
		end
	end,

	settings = {
		-- see loadSettingsDefaults
		uiscale = {
			type = "number",
			name = _("setting_uiscale"),
			description = _("setting_uiscale_desc"),
			default = 1,
			max = 3.0,
			order = 2,
		},

		flexstreets = {
			type = "boolean",
			name = _("setting_flexstreets"),
			description = _("setting_flexstreets_desc"),
			default = true,
			order = 9,
		},

		linedestination = {
			type = "boolean",
			name = _("setting_enablelinedestination"),
			description = _("setting_enablelinedestination_desc"),
			default = true,
			order = 10,
		},

		newevents = {
			type = "boolean",
			name = _("setting_enablenewevents"),
			description = _("setting_enablenewevents_desc"),
			default = false,
			order = 11,
		},

		layerview = {
			type = "number",
			subtype = "integer",
			min = 0,
			max = 2,
			name = _("setting_layerview"),
			description = _("setting_layerview_desc"),
			default = 0,
			order = 12,
		},

		fixscripts = {
			type = "boolean",
			name = _("setting_fixscripts"),
			description = _("setting_fixscripts_desc"),
			default = true,
			order = 15,
		},


		verbosity = {
			type = "number",
			subtype = "integer",
			name = _("setting_verbosity"),
			description = _("setting_verbosity_desc"),
			default = 0,
			min = 0,
			max = 99,
			order = 99,
		},

		enableluasocket = {
			type = "boolean",
			name = _("setting_enableluasocket"),
			default = false,
			description = _("setting_enableluasocket_desc"),
			order = 201,
		},

		location7zip = {
			type = "string",
			default = "",
			name = _("setting_location7zip"),
			description = _("setting_location7zip_desc"),
			order = 250,
		},

		disablenative = {
			type = "boolean",
			name = _("setting_disablenative"),
			description = _("setting_disablenative_desc"),
			order = 300,
		},

		rendermode = {
			type = "number",
			subtype = "integer",
			default = 1,
			name = _("setting_rendermode"),
			description = _("setting_rendermode_desc"),
			order = 301,
		},


		buildoverwrite = {
			type = "string",
			default = "",
			name = _("setting_buildoverwrite"),
			description = _("setting_buildoverwrite_desc"),
			order = 303,
		},

	},
}
end